/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
****************************************************/

#include <bcm2835.h>
#include <stdio.h>
#include "nv3203b.h"

char buffer[TFT_WIDTH * TFT_HEIGHT * 2];

void command(char cmd) {
    bcm2835_gpio_write(DC, LOW);
    bcm2835_spi_transfer(cmd);
}

void data(char cmd) {
    bcm2835_gpio_write(DC, HIGH);
    bcm2835_spi_transfer(cmd);
}

void nv3203b_begin()
{
    bcm2835_gpio_fsel(RST, BCM2835_GPIO_FSEL_OUTP);
    bcm2835_gpio_fsel(DC, BCM2835_GPIO_FSEL_OUTP);

    bcm2835_spi_begin();
    bcm2835_spi_setBitOrder(BCM2835_SPI_BIT_ORDER_MSBFIRST);     //The default
    bcm2835_spi_setDataMode(BCM2835_SPI_MODE0);                  //The default
    bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_1024);  //The default
    bcm2835_spi_chipSelect(BCM2835_SPI_CS0);                     //The default
    bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS0, LOW);     //the default

    bcm2835_gpio_write(RST, HIGH);
    bcm2835_delay(10);
    bcm2835_gpio_write(RST, LOW);
    bcm2835_delay(20);
    bcm2835_gpio_write(RST, HIGH);
    bcm2835_delay(50);
	
 
//----------------Star Initial Sequence-------//
 	command(0xff);
	data(0xa5); //
 	command(0x3E);
	data(0x08); //
 	command(0x3A);
	data(0x55);
 	command(0x82);
	data(0x00);
 	command(0x98);
	data(0x00);
 	command(0x63);
	data(0x10);
 	command(0x64);
	data(0x10);
 	command(0xB4);
	data(0x34); // 34 55
 	command(0xB5);
	data(0x30);
 	command(0x83);
	data(0x03);
 	command(0x86); //
	data(0x00);
 	command(0x87);
	data(0x16);
 	command(0x88); // VCOM
	data(0x09);
 	command(0x89); //
	data(0x2f);
 	command(0x93); //
	data(0x63);
 	command(0x96);
	data(0x81);
 	command(0xC3);
	data(0x01); //
 	command(0xE6);
	data(0x00);
 	command(0x99);
	data(0x01);
    ////////////////////////gamma_set//////////////////////////////////////
 	command(0x70);
	data(0x07); // VRP 0
 	command(0x71);
	data(0x1b); // VRP 1
 	command(0x72);
	data(0x08); // VRP 2
 	command(0x73);
	data(0x0f); // VRP 3
 	command(0x74);
	data(0x16); // VRP 6
 	command(0x75);
	data(0x1A); // VRP 8
 	command(0x76);
	data(0x3c); // VRP 10
 	command(0x77);
	data(0x0a); // VRP 14
 	command(0x78);
	data(0x05); // VRP 17
 	command(0x79);
	data(0x3a); // VRP 21
 	command(0x7a);
	data(0x06); // VRP 23
 	command(0x7b);
	data(0x0b); // VRP 25
 	command(0x7c);
	data(0x12); // VRP 28
 	command(0x7d);
	data(0x0b); // VRP 29
 	command(0x7e);
	data(0x0a); // VRP 30
 	command(0x7f);
	data(0x08); // VRP 31
 	command(0xa0);
	data(0x0b); // VRN 0
 	command(0xa1);
	data(0x36); // VRN 1
 	command(0xa2);
	data(0x0b); // VRN 2
 	command(0xa3);
	data(0x0c); // VRN 3
 	command(0xa4);
	data(0x08); // VRN 6
 	command(0xa5);
	data(0x22); // VRN 8
 	command(0xa6);
	data(0x43); // VRN 10
 	command(0xa7);
	data(0x04); // VRN 14
 	command(0xa8);
	data(0x05); // VRN 17
 	command(0xa9);
	data(0x3F); // VRN 21
 	command(0xaa);
	data(0x0A); // VRN 23
 	command(0xab);
	data(0x11); // VRN 25
 	command(0xac);
	data(0x0d); // VRN 28
 	command(0xad);
	data(0x06); // VRN 29
 	command(0xae);
	data(0x3b); // VRN 30
 	command(0xaf);
	data(0x07); // VRN 31
    //////////////////////////////////////////////////////////////////
 	command(0xff);
	data(0x00);

 	command(0x36); // MX, MY, RGB mode
   	data(0x48);

  command(0x11); 
    bcm2835_delay(120);
  command(0x29); 


    bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_64);  //The default

  
  nv3203b_clear();






}

void nv3203b_clear() {
    int i;
    for(i = 0; i < sizeof(buffer); i++)
    {
        buffer[i] = 0;
    }
}

void nv3203b_draw_point(int x, int y, uint16_t hwColor) {
    if(x >= TFT_WIDTH || y >= TFT_HEIGHT)
    {
        return;
    }
    buffer[x * 2 + y * TFT_WIDTH * 2] = hwColor >> 8;
    buffer[x * 2 + y * TFT_WIDTH * 2 + 1] = hwColor;
}

void nv3203b_char1616(uint8_t x, uint8_t y, uint8_t chChar, uint16_t hwColor) {
    uint8_t i, j;
    uint8_t chTemp = 0, y0 = y;

    for (i = 0; i < 32; i ++) {
        chTemp = Font1612[chChar - 0x30][i];
        for (j = 0; j < 8; j ++) {
            if (chTemp & 0x80) {
                nv3203b_draw_point(x, y, hwColor);
            } else {
                nv3203b_draw_point(x, y, 0);
            }
            chTemp <<= 1;
            y++;
            if ((y - y0) == 16) {
                y = y0;
                x++;
                break;
            }
        }
    }
}

void nv3203b_char3216(uint8_t x, uint8_t y, uint8_t chChar, uint16_t hwColor) {
    uint8_t i, j;
    uint8_t chTemp = 0, y0 = y; 

    for (i = 0; i < 64; i++) {
        chTemp = Font3216[chChar - 0x30][i];
        for (j = 0; j < 8; j++) {
            if (chTemp & 0x80) {
                nv3203b_draw_point(x, y, hwColor);
            } else {
                nv3203b_draw_point(x, y, 0);
            }

            chTemp <<= 1;
            y++;
            if ((y - y0) == 32) {
                y = y0;
                x++;
                break;
            }
        }
    }
}

void nv3203b_char(uint8_t x, uint8_t y, char acsii, char size, char mode, uint16_t hwColor) {
    uint8_t i, j, y0=y;
    char temp;
    uint8_t ch = acsii - ' ';
    for(i = 0;i<size;i++) {
        if(size == 12)
        {
            if(mode)temp=Font1206[ch][i];
            else temp = ~Font1206[ch][i];
        }
        else 
        {            
            if(mode)temp=Font1608[ch][i];
            else temp = ~Font1608[ch][i];
        }
        for(j =0;j<8;j++)
        {
            if(temp & 0x80) nv3203b_draw_point(x, y, hwColor);
            else nv3203b_draw_point(x, y, 0);
            temp <<=1;
            y++;
            if((y-y0)==size)
            {
                y = y0;
                x ++;
                break;
            }
        }
    }
}

void nv3203b_string(uint8_t x, uint8_t y, const char *pString, uint8_t Size, uint8_t Mode, uint16_t hwColor) {
    while (*pString != '\0') {       
        if (x > (TFT_WIDTH - Size / 2)) {
            x = 0;
            y += Size;
            if (y > (TFT_HEIGHT - Size)) {
                y = x = 0;
            }
        }
        
        nv3203b_char(x, y, *pString, Size, Mode, hwColor);
        x += Size / 2;
        pString ++;
    }
}

void nv3203b_mono_bitmap(uint8_t x, uint8_t y, const uint8_t *pBmp, char chWidth, char chHeight, uint16_t hwColor) {
    uint8_t i, j, byteWidth = (chWidth + 7) / 8;
    for(j = 0; j < chHeight; j++) {
        for(i = 0; i <chWidth; i ++) {
            if(*(pBmp + j * byteWidth + i / 8) & (128 >> (i & 7))) {
                nv3203b_draw_point(x + i, y + j, hwColor);
            }
        }
    }        
}

void nv3203b_bitmap24(uint8_t x, uint8_t y, uint8_t *pBmp, char chWidth, char chHeight) {
    uint8_t i, j;
    uint16_t hwColor;
    uint32_t temp;

    for(j = 0; j < chHeight; j++) {
        for(i = 0; i < chWidth; i ++) {
            temp = *(unsigned int*)(pBmp + i * 3 + j * 3 * chWidth);
            hwColor = RGB(((temp >> 16) & 0xFF),
                          ((temp >> 8) & 0xFF),
                           (temp & 0xFF));
            nv3203b_draw_point(x + i, y + chHeight - 1 - j, hwColor);
        }
    }
}


void nv3203b_bitmap16(uint8_t x, uint8_t y, const uint8_t *pBmp, char chWidth, char chHeight) {
    uint8_t i, j,temp;
    uint16_t hwColor;


    for(j = 0; j < chHeight; j++) {
        for(i = 0; i < chWidth; i ++) {
            hwColor= (*pBmp++);
            hwColor = hwColor<<8;
            temp = (*pBmp++);
	    hwColor = hwColor|temp;         
            nv3203b_draw_point(x + i, y + j, hwColor);
        }
    }
}


void nv3203b_display() {
 
    command(0x2a);
    data(0);
    data(0);
    data((TFT_WIDTH-1) >> 8);
    data(TFT_WIDTH-1);

    command(0x2b);
    data(0);
    data(0);
    data((TFT_HEIGHT-1) >> 8);
    data(TFT_HEIGHT-1);

    command(0x2C);
    bcm2835_gpio_write(DC, HIGH);
    bcm2835_spi_transfern(buffer, sizeof(buffer));
}

void nv3203b_clear_screen(uint16_t hwColor) {
    uint16_t i, j;
    for(i = 0; i < TFT_HEIGHT; i++) {
        for(j = 0; j < TFT_WIDTH; j ++) {
            nv3203b_draw_point(j, i, hwColor);
        }
    }
}

